/*****************************************************************************
**  This is part of the CTSim program
**  Copyright (C) 1983-2000 Kevin Rosenberg
**
**  $Id: cio.h,v 1.6 2000/05/08 20:00:47 kevin Exp $
**  $Log: cio.h,v $
**  Revision 1.6  2000/05/08 20:00:47  kevin
**  ANSI C changes
**
**  Revision 1.5  2000/05/07 12:46:19  kevin
**  made c++ compatible
**
**  Revision 1.4  2000/04/28 18:18:59  kevin
**  removed unused files
**
**  Revision 1.3  2000/04/28 14:14:16  kevin
**  *** empty log message ***
**
**
**  This program is free software; you can redistribute it and/or modify
**  it under the terms of the GNU General Public License (version 2) as
**  published by the Free Software Foundation.
**
**  This program is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**  GNU General Public License for more details.
**
**  You should have received a copy of the GNU General Public License
**  along with this program; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
******************************************************************************/
#ifndef __CIO_H
#define __CIO_H

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */


struct crtv_st {
    int init;		/* True if initialized */
    int bios_mode;	/* Current BIOS crt mode */
    int text_attr;	/* Current text attribute */
    int act_page;	/* Active page */
    int tcols, trows;	/* Maximum text coords */
    int xmax, ymax;	/* Maximum x, y for both text & graphic modes */
    int cx, cy;		/* Current x, y position */
}; 

#ifndef DEFINE_CRTV
   extern struct crtv_st crtv;
#endif

/*----------------------------------------------------------------------*/

#define CRT_ROWS  25
#define CRT_COLS  80

/*----------------------------------------------------------------------*/

#define  ATTR_NORMAL     7
#define  ATTR_REVERSE   14
#define  ATTR_HIGHLIGHT 15

#define C_BLACK	     0			/* color codes */
#define C_BLUE       1
#define C_GREEN	     2
#define C_CYAN       3
#define C_RED	     4
#define C_MAGENTA    5
#define C_BROWN      6
#define C_WHITE      7
#define C_GREY       8
#define C_LTBLUE     9
#define C_LTGREEN   10
#define C_LTCYAN    11
#define C_LTRED     12
#define C_LTMAGENTA 13
#define C_YELLOW    14
#define C_LTWHITE   15

/*----------------------------------------------------------------------*/

/* screen character codes */

#define SC_BKSP		  8
#define SC_TAB		  9
#define SC_BLANK	' '


#define WAITKEY()	{cio_kb_clr(); while (cio_kb_read() == 0);}

/* center.c */
void crt_center_line(const char *str);
/* clreol.c */
void cio_clreol(void);
/* clrline.c */
void cio_clrline(unsigned int line);
/* clrscrn.c */
void crt_clrscrn(void);
/* cpos.c */
void cio_tab(unsigned int n);
void cio__save_cpos(void);
void cio__restore_cpos(void);
/* fill_eol.c */
void cio_fill_eol(int c, int attr);
/* getstate.c */
void cio_get_state(void);
/* put_ca.c */
void cio_set_text_clr(int fclr, int bclr);
int cio_get_texta(void);
void cio_set_texta(int a);
int cio_blank_attr(void);
void cio_put_ca(int c, int attr);
void cio_put_c(int c);
void cio_put_cc(int c, int count);
void cio_put_cca(int c, int attr, int count);
void cio_put_str(const char *str);
void cio_put_stra(const char *str, int attr);
void cio_inc_col(int count);
void cio_dec_col(int count);
void cio_dec_row(int count);
/* setcpos.c */
void cio_set_cpos(int col, int row);
void cio_get_cpos(int *col, int *row);
/* beep.c */
void cio_beep(void);
/* kb_chk.c */
int cio_kb_chk(void);
/* kb_clr.c */
void cio_kb_clr(void);
/* kb_getc.c */
unsigned int cio_kb_getc(void);
void cio_kb_ungetc(unsigned int c);
/* kb_gets.c */
char *cio_kb_gets(char *str, int maxlen);
/* kb_read.c */
unsigned int cio_kb_read(void);
void cio_kb_unread(unsigned int c);
/* kb_waitc.c */
unsigned int cio_kb_waitc(const char *astr, const char *estr, int beep_on_error);
/* tone.c */
void cio_tone(double freq, double length);
/* check_kb */
int cio_check_kb_escape(void);

#ifdef _cplusplus
}
#endif /* _cplusplus */

#endif
